package comparisonExample5; // http://www.onjava.com/pub/a/onjava/2003/03/12/java_comp.html

import java.util.Comparator;

public class Person implements Comparable<Person> {
	public static final Comparator<Person> LAST_NAME_COMPARATOR = new LastNameComparator();
	public static final Comparator<Person> FIRST_NAME_COMPARATOR = new FirstNameComparator();

	private String firstName;
	private String lastName;
	private int age;

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public int getAge() {
		return age;
	}

	public void setAge(int age) {
		this.age = age;
	}

	public int compareTo(Person anotherPerson) {
		return this.age - anotherPerson.getAge();
	}

	private static class LastNameComparator implements Comparator<Person> {
		public int compare(Person person, Person anotherPerson) {
			String lastName1 = person.getLastName().toUpperCase();
			String firstName1 = person.getFirstName().toUpperCase();
			String lastName2 = anotherPerson.getLastName().toUpperCase();
			String firstName2 = anotherPerson.getFirstName().toUpperCase();

			if (!(lastName1.equals(lastName2))) // This is the equals method from String
				return lastName1.compareTo(lastName2); // This is the compareTo method from String
			else
				return firstName1.compareTo(firstName2); // This is also the compareTo method from String
		}
	}

	private static class FirstNameComparator implements Comparator<Person> {
		public int compare(Person person, Person anotherPerson) {
			String lastName1 = person.getLastName().toUpperCase();
			String firstName1 = person.getFirstName().toUpperCase();
			String lastName2 = anotherPerson.getLastName().toUpperCase();
			String firstName2 = anotherPerson.getFirstName().toUpperCase();

			if (!(firstName1.equals(firstName2))) // This is the equals method from String
				return firstName1.compareTo(firstName2); // This is the compareTo method from String
			else
				return lastName1.compareTo(lastName2); // This is also the compareTo method from String
		}
	}
}